﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package {
	import flash.display.Bitmap;
	import com.actionscriptfacile.ui.text.UITextField;

	import com.as3facile.DefaultButton;

	import flash.events.MouseEvent;
	
	import com.demonsters.debugger.MonsterDebugger;
	
	import flash.events.Event;
	import flash.display.Sprite;
	
	
	
	// definit la couleur de fond du swf
	[SWF(backgroundColor="0xffffff")] 

	public class Main extends Sprite
	{
		private var oInfosEvents : UITextField;
		
		private var iCpt : int = 0;
		private var oIconFlash : Bitmap;
		
		

		/**
		 * Constructeur.
		 * 
		 * Compiler avec le SDK Flex 4.6
		 * 
		 * -swf-version = 18 : pour l'API Flash Player 11.5
		 * -default-frame-rate 40 : nombre d'images par secondes
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * 
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Events");
			
			this.buildUI();
		}


		/**
		 * Construit l'affichage de l'application.
		 * 
		 * 
		 */
		private function buildUI() : void
		{
			// ajoute une image de la bibliothèque sur la scène
			var oIconBitmapData:AdobeFlash = new AdobeFlash() ;
			oIconFlash = new Bitmap (oIconBitmapData) ;
			oIconFlash.x = 169 ;// positionner l'image
			oIconFlash.y = -25 ;
			oIconFlash.scaleX = oIconFlash.scaleY = 0.6;// réduire la taille de l'image
			oIconFlash.smoothing = true ;// lissage améliore le rendu de l'image
			oIconFlash.rotation = 31 ;
			addChild(oIconFlash) ;


			// ajout d'un texte informatif
			oInfosEvents = this.addText("En attente de réception d'un évènement...");
			oInfosEvents.x = 25;
			oInfosEvents.y = 331;
			this.addChild(oInfosEvents);
			
			
			// Création des boutons
			var oBtnStart:DefaultButton = new DefaultButton();
			oBtnStart.getObject().label = "Envoie Events Txt";
			oBtnStart.getObject().x = stage.stageWidth - oBtnStart.width - 169;
			oBtnStart.getObject().y = 25;
			oBtnStart.getObject().addEventListener ( MouseEvent.CLICK, onSendEventsText );// ajout d'un écouteur de l'évènement MouseEvent.CLICK
			this.addChild(oBtnStart);
			
			
			
			var oBtnStartGame:DefaultButton = new DefaultButton();
			oBtnStartGame.getObject().label = "Envoie Events Txt Icon";
			oBtnStartGame.getObject().x = stage.stageWidth - oBtnStartGame.width - 31;
			oBtnStartGame.getObject().y = 25;
			oBtnStartGame.getObject().addEventListener ( MouseEvent.CLICK, onSendEventsIcon );// ajout d'un écouteur de l'évènement MouseEvent.CLICK
			oBtnStartGame.getObject().addEventListener ( MouseEvent.CLICK, onSendEventsText );// ajout d'un écouteur de l'évènement MouseEvent.CLICK
			this.addChild(oBtnStartGame);
			
			// Création d'un bouton
			var oBtnStartIcon:DefaultButton = new DefaultButton();
			oBtnStartIcon.getObject().label = "Envoie Events Icon";
			oBtnStartIcon.getObject().x = stage.stageWidth - oBtnStartGame.width - 31;
			oBtnStartIcon.getObject().y = 69;
			oBtnStartIcon.getObject().addEventListener ( MouseEvent.CLICK, onSendEventsIcon );// ajout d'un écouteur de l'évènement MouseEvent.CLICK
			this.addChild(oBtnStartIcon);
		}



		/**
		 * Appel dès qu'il y a un clique sur le bouton écouté (oBtnStartIcon et oBtnStartGame)
		 * 
		 */
		private function onSendEventsIcon(event : MouseEvent) : void
		{
			oIconFlash.visible = ! oIconFlash.visible;// affiche / masque l'icone flash 
		}


		/**
		 * Appel à chaque appui sur le bouton oBtnStartGame
		 * 
		 * onSendEventsText est un écouteur de DefaultButton
		 * 
		 */
		private function onSendEventsText(event : MouseEvent) : void
		{
			iCpt++;
			
			// gestion du pluriel
			if( iCpt < 2)
				oInfosEvents.text = iCpt+" réception de l'évènement.";	
			else
				oInfosEvents.text = iCpt+" réceptions de l'évènement.";
				
			oInfosEvents.appendText("\nLe logo flash est visible : "+oIconFlash.visible);
		}


		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.changeFormat("bold", true);
			oTxtField.changeFormat("size", 26);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x006f77);// changement de la couleur
			
			return oTxtField;	 
		}		


	}
}
